      $set ans85 align(4) mf noosvs
      *
      * Copyright (c) 1992 Novell, Inc.  All Rights Reserved.
      *
      * THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
      * TREATIES.  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE
      * LICENSE AGREEMENT ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK)
      * THAT CONTAINS THIS WORK.
      *
      * Pursuant to the SDK License Agreement, Novell hereby grants to
      * Developer a royalty-free, non-exclusive license to include the
      * sample code FETCHUID.CBL and NWCOBDLL.CBL and derivative binaries 
      * in its product.  Novell grants to Developer worldwide distribution
      * rights to market, distribute or sell the sample code FETCHUID.CBL and
      * NWCOBDLL.CBL and derivative binaries as a component of Developer's 
      * product(s).  Novell shall have no obligations to Developer or Developer's
      * customers with respect to this code.
      *
      * DISCLAIMER:
      *
      * Novell, Inc. makes no representations or warranties with respect
      * to the contents or use of this code, and specifically disclaims any
      * express or implied warranties of merchantability or fitness for any
      * particular purpose.  Further, Novell, Inc. reserves the right to revise
      * this publication and to make changes to its content, at any time,
      * without obligation to notify any person or entity of such revisions or
      * changes.
      *
      * Further, Novell, Inc. makes no representations or warranties with
      * respect to any software, and specifically disclaims any express or
      * implied warranties of merchantability or fitness for any particular
      * purpose.  Further, Novell, Inc. reserves the right to make changes to
      * any and all parts of the software, at any time, without obligation to
      * notify any person or entity of such changes.
      *
      * File: FETCHUID.CBL and NWCOBDLL.CBL
      *    
      * Description:
      *            FETCHUID.CBL and NWCOBDLL.CBL are MicroFocus Cobol applications
      *          which demonstrate how to make NetWare SDK calls from within Cobol.
      *          Novell would like to thank Jim Wilson from VAL Systems for providing
      *          this sample code to Novell.
      *            While Novell does not specifically support Cobol as an application
      *          development environment, we are providing this sample code in order
      *          to help those customers needing this functionality.  This sample
      *          code encompasses Novell's support for this environment.
      *
      *
      * Programmers:
      *
      *          Ini          Who                      Firm
      *          -------------------------------------------------------------------
      *          JW        Jim Wilson            VAL Systems, Pen Argyl, Pa 18072
      *
      * History:
      *
      *          When               Who             What
      *          -------------------------------------------------------------------
      *          06-24-96           JW             First code.
      *
      *
      *    compile to obj with "case" specified in options
      *
      *    link to exe
      *        cbllink fetchuid
      *
      *
       identification division.
       program-id.  fetchuid.
       environment division.
       configuration section.
       source-computer.  ibm-pc.
       object-computer.  ibm-pc.
       special-names.
           console is crt
           cursor is pos.

      *--------------------------------------------------------------*

       data division.
       working-storage section.
       01  prog-name   pic x(20) value "****FETCHUID****".

       01  pos             pic 9(4) value 1.

      *
      *    display field used if error is returned from call
      *
       01  disp-stat           pic 9(16).

      *
      *    arguement passed to dll.  Status is returned in arguement.
      *
       01  nw-arg.
           02  nw-stat             pic x(4) comp-5.
           02  nw-hand             pic x(4) comp-5.
           02  nw-conn             pic x(4) comp-5.
           02  nw-user             pic x(48).
           02  nw-type             pic x(2) comp-5.
           02  nw-obid             pic x(4) comp-5.
      /
       procedure division.

       main-process section.

      *    clear the screen

           display spaces.

      *    load the dll

           call "NWCOBDLL.DLL" using nw-arg.

      *    call the entry point to get the User ID

           call "GETUSERID" using by reference nw-arg.

      *    check the status returned for a good call
      *    if it is a good call, I replace nulls with
      *    spaces (C does null terminated strings) then
      *    display the user id upon the screen else if
      *    not a good status display the error in decimal.
      *    The user will have to convert it to hex to
      *    evaluate it in the documentation.

           if nw-stat is equal to zero
               inspect nw-user replacing all x"00" by " "
               display nw-user upon crt at 1201
           else
               move nw-stat to disp-stat
               display disp-stat upon crt at 1401
           end-if.

      *    terminate program.

           stop run.

