      $set ans85 mf noosvs align(4) case
      *
      * Copyright (c) 1992 Novell, Inc.  All Rights Reserved.
      *
      * THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND
      * TREATIES.  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE
      * LICENSE AGREEMENT ACCOMPANYING THE SOFTWARE DEVELOPMENT KIT (SDK)
      * THAT CONTAINS THIS WORK.
      *
      * Pursuant to the SDK License Agreement, Novell hereby grants to
      * Developer a royalty-free, non-exclusive license to include the
      * sample code FETCHUID.CBL and NWCOBDLL.CBL and derivative binaries 
      * in its product.  Novell grants to Developer worldwide distribution
      * rights to market, distribute or sell the sample code FETCHUID.CBL and
      * NWCOBDLL.CBL and derivative binaries as a component of Developer's 
      * product(s).  Novell shall have no obligations to Developer or Developer's
      * customers with respect to this code.
      *
      * DISCLAIMER:
      *
      * Novell, Inc. makes no representations or warranties with respect
      * to the contents or use of this code, and specifically disclaims any
      * express or implied warranties of merchantability or fitness for any
      * particular purpose.  Further, Novell, Inc. reserves the right to revise
      * this publication and to make changes to its content, at any time,
      * without obligation to notify any person or entity of such revisions or
      * changes.
      *
      * Further, Novell, Inc. makes no representations or warranties with
      * respect to any software, and specifically disclaims any express or
      * implied warranties of merchantability or fitness for any particular
      * purpose.  Further, Novell, Inc. reserves the right to make changes to
      * any and all parts of the software, at any time, without obligation to
      * notify any person or entity of such changes.
      *
      * File: FETCHUID.CBL and NWCOBDLL.CBL
      *    
      * Description:
      *            FETCHUID.CBL and NWCOBDLL.CBL are MicroFocus Cobol applications
      *          which demonstrate how to make NetWare SDK calls from within Cobol.
      *          Novell would like to thank Jim Wilson from VAL Systems for providing
      *          this sample code to Novell.
      *            While Novell does not specifically support Cobol as an application
      *          development environment, we are providing this sample code in order
      *          to help those customers needing this functionality.  This sample
      *          code encompasses Novell's support for this environment.
      *
      *
      * Programmers:
      *
      *          Ini          Who                      Firm
      *          -------------------------------------------------------------------
      *          JW        Jim Wilson            VAL Systems, Pen Argyl, Pa 18072
      *
      * History:
      *
      *          When               Who             What
      *          -------------------------------------------------------------------
      *          06-24-96           JW             First code.
      *
      *
      *    compile into obj with "case" specified in options
      *
      *    link to dll
      *        cbllink -d nwcobdll calwin32.lib
      *
      *
       identification division.
       program-id.  nwcobdll.
       environment division.
       configuration section.
       source-computer.  ibm-pc.
       object-computer.  ibm-pc.
       special-names.
           console is crt
           cursor is pos

      *
      *    The following call convention is needed for all calls to
      *    Novell routines.
      *

           call-convention 72 is api.
      /
       data division.
       working-storage section.
       01  prog-name   pic x(20) value "****NWCOBDLL****".

       01  pos                     pic 9(4) value 1.

       01  null-ptr                usage is pointer.
       01  nw-init                 pic 9 value zero.
       01  nw-zero                 pic xx comp-5 value zero.
       01  nw-bytes                pic x(4) comp-5 value zero.
       01  nw-hold                 pic x(4).
       01  stat                    pic 9(4) comp-5 value zero.
      /
       linkage section.

       01  nw-arg.
           02  nw-stat             pic x(4) comp-5.
           02  nw-hand             pic x(4).
           02  nw-conn             pic x(4).
           02  nw-user             pic x(48).
           02  nw-type             pic x(2).
           02  nw-obid             pic x(4).
      /
       procedure division using nw-arg.

       begin-nwcobol section.

      *
      *    Initial call to load the dll will execute this code.
      *    It will initialize Novell Calls and return to caller.
      *

           set null-ptr to null.
           call api "NWCallsInit" using by value null-ptr
                                        by value null-ptr
                                        returning nw-stat.
           exit program.


      *----------------------------------------------------------------*


       entry "GETUSERID" using by reference nw-arg.

      *
      *    Go get the Primary Connection Id (Server Handle)
      *
      *    Notice pointer (by reference) is passed to Novell
      *
      *
           call api "NWGetPrimaryConnectionID"
                                            using by reference nw-hand
                                                  returning nw-stat.

      *
      *    Go get the Connection Number
      *
      *    Notice value of nw-hand (by value) is passed to Novell
      *        not the pointer to it
      *    Notice pointer to nw-conn (by reference) is passed to Novell
      *
      *
           call api "NWGetConnectionNumber" using by value nw-hand
                                                  by reference nw-conn
                                                  returning nw-stat.

      *
      *    Go get the Connection Information
      *
      *    Notice a null pointer is passed as last parameter
      *        because it is an optional arg and I don't want it.
      *
           call api "NWGetConnectionInformation" using
                                          by value nw-hand
                                          by value nw-conn
                                          by reference nw-user
                                          by reference nw-type
                                          by reference nw-obid
                                          by value null-ptr
                                          returning nw-stat.
           exit program.


      *----------------------------------------------------------------*
      ****************************************************************
